
RENDER_PLOTS = 0;
PRINT_OUTPUT = 0;
CHECK_GRAD = 0;

VALID_ROAD_TYPES = [1,2];
MAX_ROAD_SPEED = 45;
MIN_ROUTE_COS_ANGLE = cos(20/360*2*pi);

K3 = 10.32;
K4 = 1.01;

GRAVITY = 9.807; % meters/sec

EARTH_RADIUS = almanac('earth', 'radius', 'meters');
RADIANS_PER_DEGREE = (2*pi)/360;

LATLON_INTERVAL = 1/(3600/3);

% Whole Downtown
LAT_RANGE = 37.65 : LATLON_INTERVAL : 37.82;
LON_RANGE = -122.52 : LATLON_INTERVAL : -122.35;

% Small section
% LAT_RANGE = 37.70 : LATLON_INTERVAL : 37.75;
% LON_RANGE = -122.45 : LATLON_INTERVAL : -122.4;

% LAT_RANGE = 37.70 : LATLON_INTERVAL : 37.80;
% LON_RANGE = -122.5 : LATLON_INTERVAL : -122.4;


GRID_SIZE = [size(LON_RANGE,2), size(LAT_RANGE,2)];

PATH_INTERVAL_MULT = 1;
PATH_INTERVAL = PATH_INTERVAL_MULT * LATLON_INTERVAL;

ACCELERATIONS_INIT = 1;

MINIMIZE_MAX_ITERS = 1000;
MINIMIZE_STEP_SIZE = 1e-3;
MINIMIZE_MOMENTUM = 0.7;
MINIMIZE_STOCH_STREAK_LENGTH = 25;
MINIMIZE_CG_STREAK_LENGTH = 5;
MINIMIZE_STREAK_BOUND = 0.001;
MINIMIZE_EPS_CHOP = 0.5;
MINIMIZE_EPS_INC = 1.05;

BIKERS = {};

% % Mountain Bike
% BIKERS{1}.K1 = 7.845;
% BIKERS{1}.K2 = 0.3872;
% BIKERS{1}.mass = 80;

% Road Bike
BIKERS{1}.K1 = 3.509;
BIKERS{1}.K2 = 0.2581;
BIKERS{1}.mass = 75;

BIKERS{1}.min_speed = 0.3;
BIKERS{1}.max_speed = 15;
BIKERS{1}.stop_speed = 5;

BIKERS{1}.timing = 1;
BIKERS{1}.effort = 5;
BIKERS{1}.effort_power = 1;
BIKERS{1}.regularity = 1000000;
BIKERS{1}.end_stopping = 1;

BIKERS{1}.init_regularity = 1;
BIKERS{1}.init_smoothness = 2;
