function DrawMap(height, graph, highlight_chain)

  imagesc(height);
  colormap('gray');
  hold on;
  scatter(graph.nodes(:,1), graph.nodes(:,2), 'o', 'markeredgecolor', [.5 .5 .5]); hold on;
  [edge_i, edge_j] = find(graph.edges);
  for i = 1:size(edge_i,1)
    line( [graph.nodes(edge_i(i),1), graph.nodes(edge_j(i),1)], [graph.nodes(edge_i(i),2), graph.nodes(edge_j(i),2)] , 'color', [.5 .5 .5]);
  end
  
  if nargin >= 3
    for i = 1:(length(highlight_chain)-1)
      line( [graph.nodes(highlight_chain(i),1), graph.nodes(highlight_chain(i+1),1)], [graph.nodes(highlight_chain(i),2), graph.nodes(highlight_chain(i+1),2)] , 'color', 'r', 'LineWidth', 2);
    end
  end
  
  axis image;
  
end