
CONSTANTS

regen_data = 0;

if regen_data

  height_map = GenerateHeightMap();

  load Data/SFStreets_graph_routes.mat

  in_range = (graph.nodes(:,1) >= LAT_RANGE(1)) & (graph.nodes(:,1) <= LAT_RANGE(end)) & (graph.nodes(:,2) >= LON_RANGE(1)) & (graph.nodes(:,2) <= LON_RANGE(end));

  graph.nodes = graph.nodes(in_range,:);
  graph.edges = graph.edges(in_range,in_range);

  old_routes = full(unique(graph.edges(graph.edges>0)));
  new_routes = find(old_routes);
  routes2(new_routes) = routes(old_routes);

  route_hash = zeros(size(old_routes));
  route_hash(old_routes) = new_routes;
  graph.edges(graph.edges>0) = route_hash(graph.edges(graph.edges>0));
  graph.routes = routes2;

  % [is,js] = find(graph.edges);
  % i = is(100);
  % j = js(100);
  % graph.nodes([i,j],:)
  % graph.edges(i,j)
  % graph.routes{graph.edges(i,j)}

  % start_costs = NaN*ones(length(graph.routes), 1);
  cont_costs = NaN*ones(length(graph.routes), 1);
  part_costs = [];

  paths = {};
  
  t_start = cputime;
  for i = 1:length(graph.routes)

    path = route2Path(graph.routes{i},height_map);
    if any(isnan(path.heights))
      % path is not cool, kill the path
      graph.edges(graph.edges == i) = 0;
      continue
    end

    %   start_costs(i) = minCost(route2Path(graph.routes{i},height_map), BIKERS{1}, 1);
    paths{i} = route2Path(graph.routes{i},height_map);
    [cost, part_cost] = minCost(paths{i}, BIKERS{1}, 0);
    cont_costs(i) = part_cost.time + part_cost.energy;
    
    t_now = cputime;
    fprintf('%0.1f%% done, %0.1f hours left\n', 100*i/length(graph.routes), ((t_now-t_start)/i * (length(graph.routes)-i))/3600);
  end

  graph.cont_costs = cont_costs;

  
  old_routes = find(~isnan(graph.cont_costs));
  new_routes = find(old_routes);
  routes2 = {};
  routes2(new_routes) = graph.routes(old_routes);

  route_hash = zeros(size(old_routes));
  route_hash(old_routes) = new_routes;
  route_hash(length(graph.routes)) = 0;
  graph.edges(graph.edges>0) = route_hash(graph.edges(graph.edges>0));
  graph.routes = routes2;
  graph.cont_costs = graph.cont_costs(old_routes);
  graph.paths = paths(old_routes);
  
  save Data/graph_costed.mat graph height_map
  
else
  
  load Data/graph_costed.mat
  
end

DrawHeightMap(height_map); hold on;
for i = 1:length(graph.paths)
%   plot(size(height_map.height,1)-graph.paths{i}.us, graph.paths{i}.vs, 'r-');
  plot(graph.paths{i}.vs, size(height_map.height,1)-graph.paths{i}.us, 'r-');
end

figure
for i = 1:length(graph.paths)
  plot(graph.paths{i}.vs, size(height_map.height,1)-graph.paths{i}.us, 'r-');
end



