
CONSTANTS

reload_data = 0;
remake_graph = 0;
refine_graph = 0;
remake_routes = 0;

if reload_data == 1
  fprintf('Reading Text\n')
  fid = fopen('Data/SFStreets.txt', 'r');
  text = fread(fid, inf, 'uint8=>char')';
  fclose(fid);

  fprintf('Parsing Text\n')
  linebreaks = strfind(text, sprintf('\n'));

  lines = {};
  comments = {};
  ncomments = 0;
  nlines = 0;
  lstart = 1;
  for l = 1:length(linebreaks)
    line = text(lstart:linebreaks(l));
    lstart = linebreaks(l)+1;

    if strcmp(line(1), '#')
      ncomments = ncomments+1;
      comments{ncomments} = line;
    else
      nlines = nlines+1;

      spaces = strfind(line, ' ');
      s_last = 1;
      sidx = 1;
      for s = spaces(1:6)
        lines{nlines, sidx} = str2num(line(s_last:s));
        s_last = s+1;
        sidx = sidx + 1;
      end
      lines{nlines, sidx} = line(s_last:end-1);

      %     lines{nlines} = line;
    end

    if mod(l, 2000) == 0
      fprintf('%0.1f%%\n', l/length(linebreaks)*100);
    end

  end

  data = lines;
  clear lines;
  save Data/SFStreets_parsed.mat data comments
  fprintf('Data Saved\n');
else
  load Data/SFStreets_parsed.mat
end

% if connect_data
%   is_valid = ismember(cat(1,data{:,1}), VALID_ROAD_TYPES) & cat(1,data{:,2}) <= MAX_ROAD_SPEED;
%   data = cell2mat(data(is_valid,3:6));
%   
%   zero11 = zeroDist(data(:,1), data(:,1));
%   zero22 = zeroDist(data(:,2), data(:,2));
% 
%   zero13 = zeroDist(data(:,1), data(:,3));
%   zero24 = zeroDist(data(:,2), data(:,4));
% 
%   zero33 = zeroDist(data(:,3), data(:,3));
%   zero44 = zeroDist(data(:,4), data(:,4));
% 
%   connections = (zero11 & zero22) | (zero13 & zero24) | (zero22 & zero44);
%   connections = (connections - speye(size(connections)))>0;
%   save Data/SFStreets_connected.mat data connections
% else
%   load Data/SFStreets_connected.mat
% end


if remake_graph
  [nodes, nodes_ui, nodes_uj] = unique([data(:,1:2); data(:,3:4)], 'rows');
  
  edges = zeros(size(data,1), 2);
  for ni = 1:size(nodes,1)
    edges((data(:,1) == nodes(ni,1)) & (data(:,2) == nodes(ni,2)),1) = ni;
    edges((data(:,3) == nodes(ni,1)) & (data(:,4) == nodes(ni,2)),2) = ni;
  end

  edge_graph = sparse(edges(:,1), edges(:,2), ones(size(edges,1),1), size(nodes,1), size(nodes,1));
  edge_graph = edge_graph | edge_graph';
  edge_graph = (edge_graph - speye(size(edge_graph)))>0;
  
  graph.nodes = nodes;
  graph.edges = edge_graph;
  
  save Data/SFStreets_graph.mat graph
  
else
  
  load Data/SFStreets_graph.mat
  
end


% scatter(graph.nodes(:,1), graph.nodes(:,2), 'bx');
% hold on;
% [ei,ej] = find(graph.edges);
% 
% for i = 1:length(ei)
%   plot(graph.nodes([ei(i);ej(i)],1), graph.nodes([ei(i);ej(i)],2), 'b-');
% end

if refine_graph

  degrees = full(sum(graph.edges))';
  deg2 = degrees == 2;
  deg2_not = ~deg2;

  [anchors,roots] = find(graph.edges);
  valid = (degrees(anchors) ~= 2) & (degrees(roots) == 2);
  anchors = anchors(valid);
  roots = roots(valid);

  to_remove = sparse(size(degrees,1),1);

  for root_i = 1:size(roots,1)

    root = roots(root_i);
    anchor = anchors(root_i);

    chain = [anchor; root];

    while true
      new_chain = setdiff(find((any(graph.edges(:,chain(end)),2))), chain);
      if isempty(new_chain)
        break
      end
      chain = [chain; new_chain];
      if degrees(new_chain)>2
        break
      end
    end
    
    if length(chain) <= 2
      continue
    end

    chain_init = chain;

    while true
      chain_v = graph.nodes(chain(2:end),:) - graph.nodes(chain(1:end-1),:);
      chain_v = chain_v./repmat(sqrt(sum(chain_v.^2,2)), 1, 2);
      chain_dot = sum(chain_v(1:end-1,:) .* chain_v(2:end,:),2);
      chain_elim = chain_dot >= MIN_ROUTE_COS_ANGLE;
      if ~any(chain_elim)
        break
      end
      label = bwlabel(chain_elim);

      for l = 1:max(label)
        in_label = find(label == l);
        to_keep = find(chain_dot(in_label) == max(chain_dot(in_label)), 1, 'first');
        chain_elim(in_label) = 0;
        chain_elim(in_label(to_keep)) = 1;
      end

      chain_elim = [0; chain_elim; 0];
      chain = chain(~chain_elim,:);
    end

    to_remove(setdiff(chain_init, chain)) = 1;

%     clf
%     plot(graph.nodes(chain,1), graph.nodes(chain,2), 'rx-'); hold on;
%     plot(graph.nodes(chain_init,1), graph.nodes(chain_init,2), 'bx-');
%     drawnow
%     pause(0.1);
  end

  for i = find(to_remove)
    neighbors = find(graph.edges(:,i));

    graph.edges(:,i) = 0;
    graph.edges(i,:) = 0;

    graph.edges(neighbors(1),neighbors(2)) = 1;
    graph.edges(neighbors(2),neighbors(1)) = 1;

  end

  graph.nodes = graph.nodes(~to_remove,:);
  graph.edges = graph.edges(~to_remove,~to_remove);

  % scatter(graph.nodes(:,1), graph.nodes(:,2), 'bx'); hold on;
  % [ei,ej] = find(graph.edges);
  % for i = 1:size(ei,1)
  %   plot([graph.nodes(ei(i),1); graph.nodes(ej(i),1)], [graph.nodes(ei(i),2); graph.nodes(ej(i),2)]); hold on;
  %   drawnow
  % end
  save Data/SFStreets_graph_refined.mat graph
else
  load Data/SFStreets_graph_refined.mat
end


if remake_routes

  % Next up: extract 2-degree chains, or single edges from 1/3/4-degree nodes
  % to other such nodes, and dump them into a cell-array of paths, and have
  % the edge matrix reference that path. Be sure to include a notion of
  % directedness. So, Edge(1,2)=-5 means that the route from 1 to 2 is the
  % inverse of path 5.

  % Will probably have to treat two-chains seperately than just single edges
  % between non-2 chains


  degrees = full(sum(graph.edges))';
  deg2 = degrees == 2;
  deg2_not = ~deg2;

  [anchors,roots] = find(graph.edges);
  valid = (degrees(anchors) ~= 2) & (degrees(roots) == 2);
  anchors = anchors(valid);
  roots = roots(valid);

  to_remove = sparse(size(degrees,1),1);

  routes = {};
  edges_route = sparse(size(graph.edges,1), size(graph.edges,2));


  for root_i = 1:size(roots,1)
    
    root = roots(root_i);
    anchor = anchors(root_i);

    chain = [anchor; root];

    while true
      new_chain = setdiff(find((any(graph.edges(:,chain(end)),2))), chain);
      if isempty(new_chain)
        break
      end
      chain = [chain; new_chain];
      if degrees(new_chain)>2
        break
      end
    end
    
    assert(length(chain) > 2)

    to_remove(chain(deg2(chain))) = 1;
    routes{root_i} = graph.nodes(chain,:);
    edges_route(chain(1), chain(end)) = root_i;

  end

  [starts, ends] = find(graph.edges);
  valid = (degrees(starts) ~= 2) & (degrees(ends) ~= 2);
  starts = starts(valid);
  ends = ends(valid);

  for i = 1:size(starts,1)
    edges_route(starts(i), ends(i)) = length(routes)+1;
    routes{length(routes)+1} = [graph.nodes(starts(i),:); graph.nodes(ends(i),:)];
  end


  to_keep = any(edges_route,1);

  graph.edges = edges_route(to_keep, to_keep);
  graph.nodes = graph.nodes(to_keep,:);
  graph.routes = routes;
  
  all_routes = full(unique(graph.edges(graph.edges>0)));
    
  save Data/SFStreets_graph_routes.mat
else
  load Data/SFStreets_graph_routes.mat
end



% streets = {};
% 
% street_idx = [0;find(~strcmp(data(2:end,end),data(1:end-1,end))); size(data,1)];
% for si = 1:(size(street_idx,1)-1)
%   start_idx = street_idx(si)+1;
%   end_idx = street_idx(si+1);
%   
%   is_valid = ismember(cat(1,data{start_idx:end_idx,1}), VALID_ROAD_TYPES);
% 
%   if ~is_valid
%     continue
%   end
%   
%   new_street.name = data{start_idx,end};
%   new_street.speed = median(cat(1,data{start_idx:end_idx,2}));
%   new_street.route = orderSegments(cell2mat(data(start_idx:end_idx,3:6)));
% 
%   streets{si} = new_street;  
%   
% end
% 
% for i = 1:size(segments,1)
%   plot(cat(1,segments(i,[1,3])), cat(1,segments(i,[2,4])), 'bx-');
%   hold on;
% end

