function does_intersect = LineSegmentIntersect(points1, points2, edges1, edges2)

if nargin == 2
  [x,y] = meshgrid(1:size(points1,1), 1:size(points1,1));
  edges1 = [x(:), y(:)];

  [x,y] = meshgrid(1:size(points2,1), 1:size(points2,1));
  edges2 = [x(:), y(:)];
end

if nargin == 3
  edges2 = edges1;
  edges1 = points2;
  points2 = points1;
end

as = points1(edges1(:,1),:);
bs = points1(edges1(:,2),:);
cs = points2(edges2(:,1),:);
ds = points2(edges2(:,2),:);


does_intersect = {};
for ei = 1:size(edges1,1)
  
  a = as(ei,:);
  b = bs(ei,:);
  
  ej = find((ccw(a,cs,ds) ~= ccw(b,cs,ds)) & (ccw(a,b,cs) ~= ccw(a,b,ds)));
  does_intersect{length(does_intersect)+1} = [repmat(ei, length(ej), 1), ej];

%   for ej = 1:size(edges2,1)
%     
%     c = cs(ej,:);
%     d = ds(ej,:);
% 
%     if (ccw(a,c,d) ~= ccw(b,c,d)) && (ccw(a,b,c) ~= ccw(a,b,d))
%       does_intersect{length(does_intersect)+1} =[ei,ej];
%     end
%   end
end

does_intersect = cat(1,does_intersect{:});
