function profile = MakeProfile(node_sequence, graph)
  
  xs = {};
  ys = {};
  for i = 1:(length(node_sequence)-1)
    n0 = node_sequence(i);
    n1 = node_sequence(i+1);
    p = graph.paths{graph.edges(n0, n1)};
    if i == 1
      xs{i} = cumsum([0; p.flat_dists]);
      ys{i} = p.heights;
    else
      xs{i} = xs{i-1}(end) + cumsum(p.flat_dists);
      ys{i} = p.heights(2:end);
    end
  end
  profile = [cat(1,xs{:}), cat(1,ys{:})];
  
  if nargout == 0
    plot(profile(:,1), profile(:,2));
  end

end