function [traversal_costs, traversal_histories, traversal] = MinTraverse(graph, n_start, parameter)
  
  costs = getfield(graph, parameter);
  
  traversal_costs = Inf*ones(size(graph.nodes,1),1);
  traversal_costs_old = traversal_costs;
  traversal_costs(n_start) = 0;

  traversal_histories = {};
  for n = 1:size(graph.nodes,1)
    traversal_histories{n} = n;
  end
  
  while ~all(traversal_costs == traversal_costs_old)

    traversal_costs_old = traversal_costs;

    for n = find(~isinf(traversal_costs))'
      edge_mat = graph.edges(:,n);

      neighbors = find(edge_mat > 0);
      neighbors_costs = costs(edge_mat(neighbors));

      for n2_i = 1:length(neighbors)
        n2 = neighbors(n2_i);
        new_cost = traversal_costs(n) + neighbors_costs(n2_i);
        if new_cost < traversal_costs(n2)
          traversal_costs(n2) = new_cost;
          traversal_histories{n2} = [traversal_histories{n}, n2];
        end
      end
    end
  end
  
end