
CONSTANTS;

rand('twister',5489);
n_paths = 10;

biker = BIKERS{1};
paths = {};
costs = zeros(n_paths,1);
part_costs = {};
accelerations = {};
part_stats = {};

for i = 1:n_paths
  paths{i} = makePath_random;
  [costs(i), part_costs{i}, accelerations{i}, part_stats{i}] = minCost(paths{i}, biker, 0);
end

max_dist = max(cellfun(@(x) sum(x.arc_dist), paths));
max_height = max(cellfun(@(x) max(x.heights), paths));

load ranking
% ranking = [1:n_paths]';
% 
% do_break = 0;
% while true
% 
%   figure(1); clf;
%   for i = 1:n_paths
%     subplot(n_paths, 1, i)
%     plot(cumsum([0; paths{ranking(i)}.arc_dist]), paths{ranking(i)}.heights, 'b-');
%     hold on;
%     axis([0, max_dist, 0, max_height]);
%     if i == 1
%       title('hardest = highest')
%     end
%     if i ~= 1
%       uicontrol('Style', 'pushbutton', 'String', 'Up', 'Position', [50 30+(n_paths-i+1)*70 40 40], 'Callback', [' move=-1; mover = ', num2str(i), ';'])
%     end
%     if i ~= n_paths
%       uicontrol('Style', 'pushbutton', 'String', 'Down', 'Position', [100 30+(n_paths-i+1)*70 40 40], 'Callback', ['move=1; mover = ', num2str(i), ';'])
%     end
%   end
%   uicontrol('Style', 'pushbutton', 'String', 'Done!', 'Position', [50 30 100 40], 'Callback', 'do_break = 1;')
%   
%   mover = 0;
%   
%   while mover == 0 && do_break == 0
%     pause(0.1);
%   end
%   
%   if do_break
%     close
%     break
%   end
%   
%   bak = ranking(mover + move);
%   ranking(mover + move) = ranking(mover);
%   ranking(mover) = bak;
% 
% end

% Should be ["higher"-"lower"]
ranking_pairs = [ranking(1:end-1), ranking(2:end)];

biker_init = biker;
accelerations_init = accelerations;
costs_init = costs;

% Gradient descent loop

loss_diff = 50;
step_size = 5e-5;

ranking_losses = [];
biker = biker_init;
biker.effort_power = 0.4;
accelerations = accelerations_init;
loss_max_count = Inf;
loss_max_score = Inf;
while true

%   r_sigma = 0.1;
%   biker.timing = biker.timing + normrnd(0,r_sigma);
%   biker.effort = biker.effort + normrnd(0,r_sigma);
%   biker.effort_power = biker.effort_power + normrnd(0,r_sigma);
  
  for i = 1:n_paths
%     [costs(i), part_costs{i}, accelerations{i}, part_stats{i}] = minCost(paths{i}, biker, 0, accelerations{i});
    [costs(i), junk, part_costs{i}, part_stats{i}] = pathCost(accelerations{i}, biker, paths{i}, 0);
  end

  d_cost_time = cellfun(@(x) x.time, part_costs)';
  d_cost_effort = cellfun(@(x) x.effort, part_costs)';
  d_cost_power = cellfun(@(x) x.D_cost_power, part_costs)';
  
  loss = max(0, costs(ranking(2:end)) - costs(ranking(1:end-1)) + loss_diff);
  loss_valid = (loss > 0);
  
  d_loss_time = loss_valid .* (d_cost_time(ranking(2:end)) - d_cost_time(ranking(1:end-1)));
  d_loss_effort = loss_valid .* (d_cost_effort(ranking(2:end)) - d_cost_effort(ranking(1:end-1)));
  d_loss_power = loss_valid .* (d_cost_power(ranking(2:end)) - d_cost_power(ranking(1:end-1)));
  
  ranking_losses = [ranking_losses; sum(loss)];
  
%   if ranking_losses(end) == min(ranking_losses)
  if (sum(loss>0) < loss_max_count) || ( sum(loss>0) <= loss_max_count && ranking_losses(end) < loss_max_score)
    loss_max_count = sum(loss>0);
    loss_max_score = ranking_losses(end);
    biker_min = biker;
  end
  
  figure(200);
  subplot(2,1,1);
  plot(costs(ranking));
  subplot(2,1,2);
  plot(ranking_losses);
  
  step_time = sum(d_loss_time) * step_size;
  step_effort = sum(d_loss_effort) * step_size;
  step_power = sum(d_loss_power) * step_size;
  
  step_time = sign(step_time) * min(0.2, abs(step_time));
  step_effort = sign(step_effort) * min(0.2, abs(step_effort));
  step_power = sign(step_power) * min(0.05, abs(step_power));
  
  biker.timing = max(0.25, biker.timing - step_time);
  biker.effort = max(0.25, biker.effort - step_effort);
  biker.effort_power = max(0.25, biker.effort_power - step_power);
  
end

