function nodes_interp = interpolate_tree(nodes, edges, LEN)

if nargin < 3
  LEN = 0.01;
end

nodes_interp = {};

for i = 1:size(edges,1)

  p1 = nodes(edges(i,1),:);
  p2 = nodes(edges(i,2),:);
  
  v = (p2 - p1);
  v_mag = sqrt(sum(v.^2));
  n = max(1, floor(v_mag/LEN));
  nodes_interp{i} = repmat([0:n]', 1, 2) .* repmat(v / n, n+1, 1) + repmat(p1, n+1, 1);
    
end
