function path = line2Path(line, map)

  height = map.height;
  meters_per_pixel = map.meters_per_pixel;
  samples_per_pixel = map.samples_per_pixel;
  
  path.pixel_dist = sqrt(sum((line(1,:) - line(2,:)).^2));
    
  path.n_steps = round(path.pixel_dist / samples_per_pixel);  
  path.n_points = path.n_steps + 1;

  pixel_step = (line(2,:) - line(1,:)) ./ path.n_steps;

  path.pixel_points = zeros(path.n_points,2);
  for i = 1:path.n_points
    path.pixel_points(i,:) = line(1,:) + pixel_step * (i-1);
  end

  path.heights = interp2(height, path.pixel_points(:,1), path.pixel_points(:,2));
  path.height_diffs = path.heights(2:end) - path.heights(1:end-1);

  path.flat_dists = sqrt(sum(((path.pixel_points(2:end,:) - path.pixel_points(1:end-1,:)).*meters_per_pixel).^2,2));
  path.true_dists = sqrt(path.height_diffs.^2 + path.flat_dists.^2); % meters

  path.grades = path.height_diffs ./ path.flat_dists; % fraction
  
  path.dist = sum(path.true_dists);
  
end