function [loss, d_loss] = lossfun(warp_W_vec, warp_points, nodes, edges, start_node_idx, costs, params)

warp_W = reshape(warp_W_vec, [], 2);

warp_W(end-2:end-1,:) = eye(2,2);
warp_W(end,:) = [0,0];

nodes_warped = TSPWarp(warp_W, warp_points, nodes);
dists_sq = (nodes_warped(:,1) - nodes_warped(start_node_idx,1)).^2 +  (nodes_warped(:,2) - nodes_warped(start_node_idx,2)).^2;
dists = sqrt(dists_sq);

% [sorted, sortidx] = sort(costs, 'ascend');
% [sorted, my_sortidx] = sort(dists, 'ascend');

roughness = sum(sum(warp_W(1:end-3,:).^2));

invert = (det(warp_W(end-2:end-1,:)) < 0.01);

loss = sum((costs - dists).^2);
% loss = sum(dists_sq ./ max(eps,costs.^2));
loss = loss + params.REGULARIZE_LAMBDA * roughness;
loss = loss + 100000*invert;
d_loss = zeros(size(warp_W_vec));

global minimize_conjugate_flag;
if minimize_conjugate_flag
  clf
  scatter(nodes_warped(:,1), nodes_warped(:,2), 1+50 .* (costs > 0), costs, 'filled')
  hold on;
  scatter(nodes_warped(start_node_idx,1), nodes_warped(start_node_idx,2), 200, 'kp', 'filled')
%   line([nodes_warped(edges(:,1),1), nodes_warped(edges(:,2),1)]', [nodes_warped(edges(:,1),2), nodes_warped(edges(:,2),2)]', 'Color', 'k')
  axis tight image;
  drawnow;
end

