function [loss, d_loss] = lossfun_laplacian(nodes_mesh_warp_vec, data, params)

nodes_mesh_warp = reshape(nodes_mesh_warp_vec, [], 2);

R90 = [0, 1; -1, 0];

vv = {};
vv_prime = {};
for i = 1:3
  iiT = data.tris(:,i);
  below = iiT <= size(data.nodes_tree,1);
  above = ~below;

  vv{i} = nan(size(data.tris,1),2);
  vv_prime{i} = nan(size(data.tris,1),2);

  vv{i}(below,:) = data.nodes_tree(iiT(below),:);
  vv{i}(above,:) = data.nodes_mesh(iiT(above)-size(data.nodes_tree,1),:);

  vv_prime{i}(below,:) = data.nodes_tree_warp(iiT(below),:);
  vv_prime{i}(above,:) = nodes_mesh_warp(iiT(above)-size(data.nodes_tree,1),:);

end

loss = 0;

for i1 = 1:3
  iis = [i1, mod(i1-1 + [1,2],3)+1];

  vec = vv{iis(2)} - vv{iis(1)};
  vec_rot = vec * R90';

  d = (vv{iis(3)} - vv{iis(1)});
  x = sum(d .* vec,2);
  y = sum(d .* vec_rot,2);

  v3_desired = [vv_prime{iis(1)}(:,1) + x.*vec(:,1) + y.*vec_rot(:,1), vv_prime{iis(1)}(:,2) + x.*vec(:,2) + y.*vec_rot(:,2)];

  loss = loss + sum(sum((v3_desired - vv{iis(3)}).^2,2));

end

d_loss = zeros(size(nodes_mesh_warp_vec));
