function [loss, d_loss] = lossfun_tree(offsets_vec, ancestry_mat, edge_idx, depths, parents, siblings, start_node_idx, costs, offsets_init, params)

global minimize_conjugate_flag;

offsets = reshape(offsets_vec, [], 2);
nodes_warp = ancestry_mat * offsets;
offsets_mag = sqrt(sum(offsets.^2,2));
offsets_norm = offsets ./ repmat(offsets_mag, 1, 2);

source_dist = sqrt((nodes_warp(:,1) - nodes_warp(start_node_idx,1)).^2 + (nodes_warp(:,2) - nodes_warp(start_node_idx,2)).^2);
source_loss = params.SOURCE_LAMBDA * sum((source_dist - costs).^2);

% inter_dist_sq = distMat(nodes_warp,nodes_warp);
% inter_dist_sq(~triu(inter_dist_sq)) = inf;
% % keyboard
% % inter_dist = sqrt(inter_dist_sq);
% % repel_loss = sum(max(0, REPEL_DIST - inter_dist(:)).^2);
% within_dist = inter_dist_sq < REPEL_DIST.^2;
% repel_loss = sum(max(0, REPEL_DIST - sqrt(inter_dist_sq(within_dist))).^2);
repel_loss = params.REPEL_LAMBDA * 0;

if params.REGULARIZE_LAMBDA ~= 0
  init_loss = params.REGULARIZE_LAMBDA * sum((offsets(:) - offsets_init(:)).^2);
end

% % if minimize_conjugate_flag
% %   fprintf('scanning\n');
%   for i = 1:size(edge_idx,1)
%     for j = (i+1) : size(edge_idx,1)
% 
%           p1 = nodes_warp(edge_idx(i,1),:);
%           p2 = nodes_warp(edge_idx(i,2),:);
%       
%           p3 = nodes_warp(edge_idx(j,1),:);
%           p4 = nodes_warp(edge_idx(j,2),:);
%       
%           x1 = p1(1);
%           y1 = p1(2);
%       
%           x2 = p2(1);
%           y2 = p2(2);
%       
%           x3 = p3(1);
%           y3 = p3(2);
%       
%           x4 = p4(1);
%           y4 = p4(2);
%       
%           d = ( (y4 - y3).*(x2 - x1) - (x4 - x3).*(y2 - y1) );
%           ua = ( (x4-x3).*(y1-y3) - (y4 - y3).*(x1 - x3) )./d;
%           ub = ( (x2-x1).*(y1-y3) - (y2-y1).*(x1-x3) )./d;
% 
%           if ua > 10^-8 && ua < (1-10^-8) && ub > 10^-8 && ub < (1-10^-8)
%             loss = inf;
%             d_loss = zeros(size(offsets_vec));
%             return
% 
% %             renderTree(nodes_warp, start_node_idx, costs, edge_idx);
% %             line([nodes_warp(edge_idx(i,1),1), nodes_warp(edge_idx(i,2),1)]', [nodes_warp(edge_idx(i,1),2), nodes_warp(edge_idx(i,2),2)]', 'Color', 'r', 'LineWidth', 3)
% %             line([nodes_warp(edge_idx(j,1),1), nodes_warp(edge_idx(j,2),1)]', [nodes_warp(edge_idx(j,1),2), nodes_warp(edge_idx(j,2),2)]', 'Color', 'r', 'LineWidth', 3)
% %             drawnow
% %             keyboard
%           end
% 
%           
% %           ub = ( (x2 - x1).*(y1 - y3) - (y2 - y1)
% 
% %       p1a = nodes_warp(edge_idx(i,1),:);
% %       p1b = nodes_warp(edge_idx(i,2),:);
% %       p2a = nodes_warp(edge_idx(j,1),:);
% %       p2b = nodes_warp(edge_idx(j,2),:);
% % 
% %       if all(p1a == p2a) || all(p1a == p2b) || all(p1b == p2a) || all(p1b == p2b)
% %         continue
% %       end
% % 
% %       x1 = [nodes_warp(edge_idx(i,1),1), nodes_warp(edge_idx(i,2),1)];
% %       y1 = [nodes_warp(edge_idx(i,1),2), nodes_warp(edge_idx(i,2),2)];
% % 
% %       x2 = [nodes_warp(edge_idx(j,1),1), nodes_warp(edge_idx(j,2),1)];
% %       y2 = [nodes_warp(edge_idx(j,1),2), nodes_warp(edge_idx(j,2),2)];
% % 
% %       if(~isempty(polyxpoly(x1,y1,x2,y2)))
% %         line([nodes_warp(edge_idx(i,1),1), nodes_warp(edge_idx(i,2),1)]', [nodes_warp(edge_idx(i,1),2), nodes_warp(edge_idx(i,2),2)]', 'Color', 'k')
% %         line([nodes_warp(edge_idx(j,1),1), nodes_warp(edge_idx(j,2),1)]', [nodes_warp(edge_idx(j,1),2), nodes_warp(edge_idx(j,2),2)]', 'Color', 'r')
% %         keyboard
% %       end
% 
%     end
%   end
% % end

valid = depths >= 3;
% grandparents = parents(parents(valid));
% d1 = offsets(parents(valid),:);
d1 = nodes_warp(parents(valid),:) - repmat(nodes_warp(start_node_idx,:), sum(valid), 1);
d1 = d1 ./ repmat(sqrt(sum(d1.^2,2)), 1, 2);

d2 = offsets_norm(valid,:);
% d2 = offsets(valid,:);
% d2 = d2 ./ repmat(sqrt(sum(d2.^2,2)), 1, 2);

orientation_loss = params.ORIENTATION_LAMBDA * sum((sum(d1 .* d2,2) - 1).^2);


sibling_loss = 0;
for s = 1:length(siblings)
  for i = 1:length(siblings{s})
    vi = offsets_norm(siblings{s}(i),:);
    for j = (i+1):length(siblings{s})
      vj = offsets_norm(siblings{s}(j),:);
      sibling_loss = sibling_loss + sum(vi .* vj,2);
    end
  end
end
sibling_loss = params.SIBLING_LAMBDA * sibling_loss;

loss = source_loss + repel_loss + orientation_loss + sibling_loss;
d_loss = zeros(size(offsets_vec));

if minimize_conjugate_flag
  renderTree(nodes_warp, start_node_idx, costs);
  drawnow;
end

