function path = makePath_random(seed)

  if nargin >= 1
    rand('twister', seed)
  end

  len = 100;
  mags = 25*(2.^[-2:5]);
  
  rs = {};
  for i = 1:length(mags)
    rs{i} = imfilter(mags(i) * rand(len, 1), fspecial('Gaussian', 5*i, i), 'symmetric', 'same');
  end
  r = sum(cat(2,rs{:}),2);
  r = r - min(r);
  xscale = rand*3.8*rand+0.2;
  yscale = rand*3.8*rand+0.2;

  x = [0:len-1]'*25*xscale;
  y = r*yscale;

  if nargout < 1
    plot(x,y); axis equal;
  end
  
  path.n_samples = length(y)-1;
  path.heights = y;
  path.arc_dist = x(2:end) - x(1:end-1);
  path.height_diff = path.heights(2:end) - path.heights(1:end-1);
  path.true_dist = sqrt(path.height_diff.^2 + path.arc_dist.^2);
  path.grade = path.height_diff ./ path.arc_dist;

end
