function height = makeRandomHeight(map)

  rand('twister', map.seed)
    
  sz = map.sz;
  mags = map.mags;
  scales = map.scales;
  
  components = {};
  for i = 1:length(mags)
    
    m = mags(i);
    s = scales(i);
    down_sz = round(sz/s);
%     down_height = m*rand(down_sz);
    down_height = m*abs(laprnd(down_sz(1), down_sz(2)));
    
    % Rectangular
    down_height([1,end],:) = 0;
    down_height(:,[1,end]) = 0;
    
    components{i} = max(0,interp2(down_height, [1:((down_sz(2) - 1) / (sz(2)-1)):down_sz(2)]', [1:((down_sz(1) - 1) / (sz(1)-1)):down_sz(1)], 'spline'));
    
  end
  height = sum(cat(3, components{:}),3);
  height([1,end],:) = 0;
  height(:,[1,end]) = 0;
  
  if nargout < 1;
    imagesc(height);
    axis image;
    colormap('gray');
  end
  
end
