function height = makeSimpleHeight(map)

  sz = map.sz;
  mag = map.mags(1);
  
  height = zeros(sz);
  [i,j] = find(~isnan(height));
  x = i - sz(1)/2;
  y = j - sz(2)/2;
  
  h = mvnpdf([x,y], [0,0], [(sz(1)/6).^2, 0; 0, (sz(1)/6).^2]);
  h = h / (max(h)/mag);
  height(sub2ind(sz, i, j)) = h;
  
  height([1,end],:) = 0;
  height(:,[1,end]) = 0;
  
  if nargout < 1;
    imagesc(height);
    axis image;
    colormap('gray');
  end
  
end
