function [X, fX] = minimize(X, f, len, varargin)

path(path, genpath('~/Work/Backup/JonUtils/'));

params = varargin{end};

step = 1;

STEP_INCREASE = 1.05;
STEP_DECREASE = 1/10;

USE_NUMERICAL = params.USE_NUMERICAL;

PRINT_TEMPLATE = '%+1.4e ';

global minimize_conjugate_flag;

% X = feval(f_constrain, X, varargin{:});

minimize_conjugate_flag = true;
if ~USE_NUMERICAL
  [f0 df0] = feval(f, X, varargin{:});          % get function value and gradient
else
  minimize_conjugate_flag = true;
  [f0] = feval(f, X, varargin{:});
  minimize_conjugate_flag = false;
  [junk, junk, df0] = findGrad(f, X, 1e-5, varargin{:});

%   [f0] = feval(f, X, varargin{:});
%   [junk, junk, df0] = findgrad(f, X, 1e-5, varargin{:});
end
minimize_conjugate_flag = false;
  
fprintf(PRINT_TEMPLATE, f0);

n_printed = 1;

fX = nan(len,1);
fX(1) = f0;

start_time = clock;

done = false;
for i = 2:len
  
  if done || ((i > params.F_STREAK+1) && all(abs((fX(i-1) - fX(i - params.F_STREAK -1: i-1))./fX(i-1)) < (params.F_PERCENT/100)))
    fprintf('Converged. ');
    break
  end

  fail_count = 0;
  while true
    
%     mask = rand(size(df0)) > 0.9;
    mask = ones(size(df0));
    
    X_new = X - (mask.*df0)*step;
    
    if fail_count == 0
      minimize_conjugate_flag = true;
    end
    if ~USE_NUMERICAL
      [f3 df3] = feval(f, X_new, varargin{:});
    else
      minimize_conjugate_flag = true;
      [f3] = feval(f, X+x3*s, varargin{:});
      minimize_conjugate_flag = false;
      [junk, junk, df3] = findGrad(f, X+x3*s, 1e-5, varargin{:});
    end
    minimize_conjugate_flag = false;
    
%     fprintf('%e, %f, %d\n', step, f3-f0, fail_count);
    
    if f3 < f0
      X = X_new;
      f0 = f3;
      fX(i) = f0;
      df0 = df3;
      step = step * STEP_INCREASE;
      
      fprintf(PRINT_TEMPLATE, f0);
      n_printed = n_printed + 1;
      if n_printed >= 8
        fprintf('\n');
        n_printed = 0;
      end
      
      break;
    else
      step = step * STEP_DECREASE;
      fail_count = fail_count + 1;
    end
    
    if (fail_count > 15)
      fprintf('Giving up.  ');
      done = true;
      break
    end
    
  end

  
end


fX = fX(1:find(~isnan(fX), 1, 'last'));

fprintf(['\n', time2human(etime(clock, start_time)), '\n']);
