function [im_contourf, im_level, im_edge] = my_contourf(im, nlevels, scale)

  sz = size(im);
  
  if nargin >= 3
    im = imresize(im, scale);
  end

  edges = min(im(:)) : (max(im(:))-min(im(:)))/(nlevels-1) : max(im(:));
  
  [N, bins] = histc(im(:), edges);
  im_level = reshape(bins, size(im));
  im_edge = edge(im_level, 'prewitt');
  
%   im_level_big = round(imresize(im_level, 2));
%   im_edge_big = imfilter(im_level_big, [-1,1], 'replicate', 'same') | imfilter(im_level_big, [-1;1], 'replicate', 'same');
%   im_edge = imresize(double(im_edge_big), 0.5);
  
%   im_level_big = imresize(im_level, 4);
%   im_edge_big = sqrt(abs(imfilter(im_level_big, [-1,1], 'replicate', 'same')).^2 + abs(imfilter(im_level_big, [-1;1], 'replicate', 'same')).^2);
%   im_edge = max(0,imresize(double(im_edge_big), 0.25));
%   
%   im_edge = im_edge/max(im_edge(:));
%   im_edge = edge(im_level, 'prewitt');
  
  im_hue = (im_level/max(im_level(:)))*0.8 + 0.2;
  
  im_contourf = hsv2rgb(im_hue, ones(size(im_level)), ones(size(im_level)) - 0.5*im_edge);
  
  if nargin >= 3
    im_contourf = min(1, max(0, imresize(im_contourf, sz)));
  end

  if nargout == 0
    figure
    imagesc(im_contourf)
    im_contourf = [];
  end
  
end



