function [d, p] = quadFun(xy, ab, rhos)
% [d, p] = quadFun(xy, ab, rhos)
% 
% rhos == || (x + d*a, y + d*b) ||
% p = (x + d*a, y + d*b)

  x = xy(:,1); y = xy(:,2);
  a = ab(:,1); b = ab(:,2);

  C = x.^2 + y.^2 - (rhos.^2);
  B = 2.*x.*a + 2.*y.*b;
  A = a.^2 + b.^2;
  ds = [(-B + sqrt(B.^2 - 4.*A.*C))./(2.*A), (-B - sqrt(B.^2 - 4.*A.*C))./(2.*A)];

  assert(sum(sum(ds > 0 & ds < 1)) == size(ds,1))
  assert(all(sum(ds > 0 & ds < 1,2) == 1))
  
  d = ds(ds > 0 & ds < 1);
  if nargout >= 2
    p = [d,d] .* [a,b] + [x,y];
  end
  
end
