function renderTree(nodes, start_node_idx, costs, edges, IS_BW)

if nargin < 5
  IS_BW = false;
end

% clf
[x,y] = cylinder(1, 100);
for r = 0.25:0.25:1
  line(r*x(1,:)' + nodes(start_node_idx,1), r*y(1,:)' + nodes(start_node_idx,2), 'Color', [0.75, 0.75, 0.75])
  hold on;
end


if nargin >= 4
  line([nodes(edges(:,1),1), nodes(edges(:,2),1)]', [nodes(edges(:,1),2), nodes(edges(:,2),2)]', 'Color', 'k')
  hold on;
end

if isempty(costs)
  scatter(nodes(:,1), nodes(:,2), 20, 'ko', 'MarkerFaceColor', [0,0,0], 'MarkerEdgeColor', 'k')
  hold on;
  scatter(nodes(start_node_idx,1), nodes(start_node_idx,2), 200, 'kp', 'filled')  
elseif IS_BW
  scatter(nodes(:,1), nodes(:,2), 1+(costs*200 + 10) .* (costs > 0), 'ko', 'MarkerFaceColor', [0,0,0])
  hold on;
  scatter(nodes(start_node_idx,1), nodes(start_node_idx,2), 200, 'kp', 'filled')
else
  scatter(nodes(:,1), nodes(:,2), 1+50 .* (costs > 0), costs, 'filled')
  hold on;
  scatter(nodes(start_node_idx,1), nodes(start_node_idx,2), 200, 'kp', 'filled')
end

plotHelp_setsize(1,1,.02)
axis image off ij;
ax = [min(nodes(:,1)), max(nodes(:,1)), min(nodes(:,2)), max(nodes(:,2))];
axis(ax);

xlim = get(gca, 'XLim');
ylim = get(gca, 'YLim');

if (ylim(2) - ylim(1)) > (xlim(2) - xlim(1))
  c = (xlim(2) + xlim(1))/2;
  d = (ylim(2) - ylim(1))/2;
  set(gca, 'XLim', [c - d, c + d]);
else
  c = (ylim(2) + ylim(1))/2;
  d = (xlim(2) - xlim(1))/2;
  set(gca, 'YLim', [c - d, c + d]);
end

set(gcf, 'Color', [1, 1, 1]);
% drawnow;