function path = route2Path(route, height_map)
  
  CONSTANTS
  
%   route_dist = sqrt(sum((route(2:end,:) - route(1:end-1,:)).^2,2));
%   route_n_samples = ceil(route_dist/PATH_INTERVAL);  
  
  path.n_samples = size(route,1)-1;

  path.lats = route(:,1);
  path.lons = route(:,2);

  [path.us, path.vs] = LatLon2UV(path.lats, path.lons);
  path.heights = interp2(height_map.height, path.us, path.vs);
  path.height_diff = path.heights(2:end) - path.heights(1:end-1);

  [xyz] = LatLon2XYZ(path.lats, path.lons);
  path.arc_dist = sqrt(sum((xyz(2:end,:) - xyz(1:end-1,:)).^2,2));

  path.true_dist = sqrt(path.height_diff.^2 + path.arc_dist.^2); % meters
  path.grade = path.height_diff ./ path.arc_dist; % fraction
  
end