function [loss, d_loss] = spaceLoss(theta, ancestry_mat, rho, edge_constraints, start_node_idx, edge_idx, grand_edge_idx, params)

SPRING_MARGIN = 0.6;

MAX_LOSS = 100000;
PUSH_LAMBDA = 1;
REG_LAMBDA = 100;


loss = 0;

% theta = ancestry_mat * theta_offset;
[x,y] = pol2cart(theta, rho);

% loss = 0;
% for i = 1:length(theta)
%   if isempty(edge_boundaries{i})
%     continue
%   end
%   for ei = 1:2
%     e = edge_boundaries{i}{ei};
%     p1 = [x(e(1)), y(e(1))];
%     p2 = [x(e(2)), y(e(2))];
%     v = p2 - p1;
% 
%     [junk, p] = quadFun(p1, v, rho(i));
%     th = cart2pol(p(1), p(2));
% 
%     d_th = thetaDist(theta(i), th);
%     loss = loss + 1./d_th;
%   end
% end

if PUSH_LAMBDA ~= 0

  p1 = [x(edge_constraints.edge_idx(:,1)), y(edge_constraints.edge_idx(:,1))];
  p2 = [x(edge_constraints.edge_idx(:,2)), y(edge_constraints.edge_idx(:,2))];
  v = p2 - p1;
  r = rho(edge_constraints.node_idx);

  [junk, p] = quadFun(p1, v, r);
  th = cart2pol(p(:,1), p(:,2));

  [d_th,o] = thetaDist(th, theta(edge_constraints.node_idx));

%   d = d_th .* (2*pi*r);
  d = d_th;

  losses = min(MAX_LOSS, 1./d);
  % losses = (max(0,SPRING_MARGIN - d).^2).* (MAX_LOSS./SPRING_MARGIN.^2);
  losses(o ~= edge_constraints.orientation) = MAX_LOSS;
  loss = loss + PUSH_LAMBDA * sum(losses);
end


if REG_LAMBDA ~= 0
  v1 = [x(grand_edge_idx(:,2)) - x(grand_edge_idx(:,1)), y(grand_edge_idx(:,2)) - y(grand_edge_idx(:,1))];
  v2 = [x(grand_edge_idx(:,3)) - x(grand_edge_idx(:,2)), y(grand_edge_idx(:,3)) - y(grand_edge_idx(:,2))];

  dv1 = sqrt(sum(v1.^2,2));
  dv2 = sqrt(sum(v2.^2,2));

  cos_angle = sum(v1 .* v2,2) ./ (dv1 .* dv2);

  loss = loss + REG_LAMBDA * sum((cos_angle - 1).^2);
end



d_loss = zeros(size(theta));


global minimize_conjugate_flag
if minimize_conjugate_flag
  
  global global_last_time
  
  if isempty(global_last_time) || ((cputime - global_last_time) > 5)
    clf
    renderTree([x,y], start_node_idx, [], edge_idx);
    drawnow;
    global_last_time = cputime;
  end
end


