function tesselate(nodes, edges)

% IM_SIZE = 512;
% 
% Xs = {}; Ys = {};
% 
% for i = 1:size(edges)
%   [X,Y] = bresenham(round(IM_SIZE*nodes(edges(i,:),1)), round(IM_SIZE*nodes(edges(i,:),2)));
%   Xs{i} = X;
%   Ys{i} = Y;
% end
% 
% Xs = cat(2,Xs{:});
% Ys = cat(2,Ys{:});
% 
% mat = zeros(IM_SIZE, IM_SIZE);
% mat(sub2ind([IM_SIZE, IM_SIZE], Xs, Ys)) = true;
% mat(1,:) = 1;
% mat(:,1) = 1;
% mat(end,:) = 1;
% mat(:,end) = 1;
% 
% D = bwdist(mat);
% 
% is_max = ((D(2:end-1,2:end-1) > D(1:end-2,2:end-1)) & (D(2:end-1,2:end-1) > D(3:end,2:end-1))) | ((D(2:end-1,2:end-1) > D(2:end-1,1:end-2)) & (D(2:end-1,2:end-1) > D(2:end-1,3:end)));
% [med_y, med_x] = find(is_max);
% med_x = (med_x + 1)/IM_SIZE; med_y = (med_y + 1)/IM_SIZE;
% 
% voronoi(nodes(:,1), nodes(:,2));
% hold on;
% 
% line([nodes(edges(:,1),1), nodes(edges(:,2),1)]', [nodes(edges(:,1),2), nodes(edges(:,2),2)]', 'Color', 'k');
% hold on;
% scatter(nodes(:,1), nodes(:,2), 20, 'ko', 'MarkerFaceColor', [0,0,0])
% hold on;
% scatter(med_x, med_y, 10, 'ro', 'filled')


% Add a bunch of points from each edge, do a voronoi tesselation, merge
% stuff together?

LEN = 0.02;

nodes_interp = {};

for i = 1:size(edges)

  p1 = nodes(edges(i,1),:);
  p2 = nodes(edges(i,2),:);
  
  v = (p2 - p1);
  v_mag = sqrt(sum(v.^2));
  n = floor(v_mag/LEN);
  nodes_interp{i} = repmat([0:n]', 1, 2) .* repmat(v / n, n+1, 1) + repmat(p1, n+1, 1);
  
end

x = [LEN:LEN:1-LEN]';
nodes_all = unique([cat(1, nodes_interp{:}); [[x, 0*x]; [0*x, x]; [x, 0*x+1]; [0*x+1, x]]], 'rows');

% voronoi(nodes_all(:,1), nodes_all(:,2))
% hold on;

[vx, vy] = voronoi(nodes_all(:,1), nodes_all(:,2));

% plot(vx,vy,'-',nodes_all(:,1),nodes_all(:,2),'.')
% hold on;

v_nodes = unique([vx(:),vy(:)], 'rows');
v_nodes = v_nodes(all(v_nodes >= 0 & v_nodes <= 1,2),:);

[tf1, loc1] = ismember([vx(1,:)', vy(1,:)'], v_nodes, 'rows');
[tf2, loc2] = ismember([vx(2,:)', vy(2,:)'], v_nodes, 'rows');

v_edges = [loc1(tf1 & tf2), loc2(tf1 & tf2)];


does_intersect = LineSegmentIntersect(nodes, v_nodes, edges, v_edges);
v_edges = v_edges(setdiff(1:size(v_edges,1), does_intersect(:,2)),:);


line([v_nodes(v_edges(:,1),1), v_nodes(v_edges(:,2),1)]', [v_nodes(v_edges(:,1),2), v_nodes(v_edges(:,2),2)]', 'Color', 'r');
hold on;
scatter(v_nodes(:,1), v_nodes(:,2), 10, 'ro', 'MarkerFaceColor', [0,0,0])

line([nodes(edges(:,1),1), nodes(edges(:,2),1)]', [nodes(edges(:,1),2), nodes(edges(:,2),2)]', 'Color', 'k');
hold on;
scatter(nodes(:,1), nodes(:,2), 20, 'ko', 'MarkerFaceColor', [0,0,0])
axis([0,1,0,1])

nodes_interped = cat(1,nodes_interp{:});
D = distMat(nodes_interped, v_nodes);
D = D - repmat(min(D, [], 1), size(D,1),1);
[i,j] = find(D <= 10^-8);

nodes_interp_edges = {};
for ni = 1:length(nodes_interp)
  [junk, loc] = ismember(nodes_interp{ni}, nodes_interped, 'rows');

  tf = ismember(i, loc);
  ii = i(tf);
  jj = j(tf);

  % Remove children who are on the other side of neighboring edges
  endpoints = edges(ni,:);
  for ei = 1:2
    n = [edges(edges(:,1) == endpoints(ei),2); edges(edges(:,2) == endpoints(ei),1)];
    n0 = endpoints(3-ei);
    n = setdiff(n, n0);
    v = nodes(n,:) - repmat(nodes(endpoints(ei),:), length(n), 1);
    v0 = nodes(n0,:) - nodes(endpoints(ei),:);
    
    th = cart2pol( [v0(1); v(:,1)], [v0(2); v(:,2)]);
    th0 = th(1);
    dth = mod(th(2:end) - th(1), 2*pi);
    sorted = sort(dth, 'ascend');

    if length(sorted) < 2
      continue
    end
    dth_range = sorted([1,end]);
    
    
    v_neighbors = v_nodes(jj,:);
    v = v_neighbors - repmat(nodes(endpoints(ei),:), size(v_neighbors,1), 1);
    th = cart2pol( [v(:,1)], [v(:,2)]);
    dth = mod(th - th0, 2*pi);
    
    keep = (dth <= dth_range(1)) | (dth >= dth_range(2));
    jj = jj(keep);
    ii = ii(keep);
  end
  
  [tf, ii] = ismember(nodes_interped(ii,:), nodes_interp{ni}, 'rows');
  
  nodes_interp_edges{ni} = [ii,jj];
  
  clf
  line([v_nodes(v_edges(:,1),1), v_nodes(v_edges(:,2),1)]', [v_nodes(v_edges(:,1),2), v_nodes(v_edges(:,2),2)]', 'Color', 'r');
  hold on;
  scatter(v_nodes(:,1), v_nodes(:,2), 10, 'ro', 'MarkerFaceColor', [0,0,0])
  line([nodes(edges(:,1),1), nodes(edges(:,2),1)]', [nodes(edges(:,1),2), nodes(edges(:,2),2)]', 'Color', 'k');
  hold on;
  scatter(nodes(:,1), nodes(:,2), 20, 'ko', 'MarkerFaceColor', [0,0,0])
  axis([0,1,0,1])

  
  plot(nodes_interp{ni}(:,1), nodes_interp{ni}(:,2), 'LineWidth', 3)  
  hold on;
  line([nodes_interp{ni}(ii,1), v_nodes(jj,1)]', [nodes_interp{ni}(ii,2), v_nodes(jj,2)]', 'Color', 'r', 'LineWidth', 2);
  scatter(v_nodes(jj,1), v_nodes(jj,2), 50, 'ro', 'MarkerFaceColor', [0,0,0])

  drawnow;
  pause
  
end




% v_nodes_rep = {};
% for vi = 1:size(v_nodes,1)
%   
%   v_nodes_rep{vi} = {};
%   
%   ns = {};
%   for ei = 1:length(nodes_interp_edges)
%     
%     idx = nodes_interp_edges{ei}(:,2) == vi;
%     
%     if ~any(idx)
%       continue
%     end
%     
%     ns{length(ns)+1} = nodes_interp{ei}(nodes_interp_edges{ei}(idx,1),:);
%     
%   end
%   
%   ns = cat(1,ns{:});
%   ns = unique(ns, 'rows');
%   
%   
%   if size(ns,1) == 1
%     v_nodes_rep{vi}{1} = v_nodes(vi,:);
%   else
%     for ri = 1:size(ns,1)
%       vec = ns(ri,:) - v_nodes(vi,:);
%       vec = vec ./ sqrt(sum(vec.^2));
%       v_nodes_rep{vi}{ri} = v_nodes(vi,:) + vec*(10^-3);
%     end
%   end
%   
% end


% v_edge_rep = {};
% for ei = 1:size(v_edges,1)
%   e = v_edges(ei,:);
% 
%   if (length(v_nodes_rep{e(1)}) >= 2) && (length(v_nodes_rep{e(2)}) >= 2) 
% 
%     points1 = cat(1,v_nodes_rep{e(1)}{:});
%     points2 = cat(1,v_nodes_rep{e(2)}{:});
% 
%     scatter(points1(:,1), points1(:,2), 30, 'ro', 'MarkerFaceColor', [1,0,0]); hold on;
%     scatter(points2(:,1), points2(:,2), 30, 'bo', 'MarkerFaceColor', [0,0,1])
% 
%     scatter(v_nodes(e(1),1), v_nodes(e(1),2), 30, 'ro', 'MarkerFaceColor', [1,1,1]); hold on;
%     scatter(v_nodes(e(2),1), v_nodes(e(2),2), 30, 'bo', 'MarkerFaceColor', [1,1,1]); hold on;
% 
%     axis image
%     
%     keyboard
% 
%   end
%   
% %   [x,y] = meshgrid(1:size(points1,1), 1:size(points1,1));
% %   edges1 = [x(:), y(:)];
% % 
% %   [x,y] = meshgrid(1:size(points2,1), 1:size(points2,1));
% %   edges2 = [x(:), y(:)];
% % 
% %   
% %   scatter(points1(:,1), points1(:,2), 10, 'ro', 'MarkerFaceColor', [0,0,0])
% 
% 
%   
% %   I = LineSegmentIntersect(points1, points2, edges1, edges2);
% %   
% %   edges1 = edges1(setdiff([1:size(edges1,1)]', I(:,1)),:);
% %   edges2 = edges2(setdiff([1:size(edges2,1)]', I(:,2)),:);
%   
% %   for ii = 1:length(v_nodes_rep{e(1)})
% %     for jj = 1:length(v_nodes_rep{e(2)})
% %       
% %       v_nodes_rep{e(1)}{ii}
% %       v_nodes_rep{e(2)}{jj}
% %       
% %     end
% %   end
% end

% 1 iterate through v_nodes, precalculate all nodes that are adjacent to it.
% 2 Repeat each v_node by the number of nodes adjacent to it. Offset each in that nodes direction
% 3 for each v_edge, make new edges that connect all repeated v_nodes for that edge. Try all possible permutations to prevent overlaps.

