function tesselate(nodes, edges)

t = [0:0.05:1]';
nodes_bordered = [nodes; unique([[t, 0*t]; [0*t, t]; [t, 1+0*t]; [1+0*t, t]], 'rows')];

% voronoi(nodes_bordered(:,1), nodes_bordered(:,2)); return
[vx, vy] = voronoi(nodes_bordered(:,1), nodes_bordered(:,2));

% nodes_border

scatter(nodes(:,1), nodes(:,2), 'ko', 'filled'); hold on;

% voronoi(nodes(:,1), nodes(:,2))

axis image off;
axis([0, 1, 0, 1])

line([nodes(edges(:,1), 1), nodes(edges(:,2), 1)]', [nodes(edges(:,1), 2), nodes(edges(:,2), 2)]', 'Color', 'k', 'LineWidth', 2)

N = size(nodes,1);
nodes_new = setdiff(unique([vx(:),vy(:)], 'rows'), nodes, 'rows');
nodes_new = nodes_new(all(nodes_new <= 1 & nodes_new >= 0,2),:);
M = size(nodes_new,1);

% scatter(nodes_new(:,1), nodes_new(:,2));

D = distMat(nodes, nodes_new);
% D = D - repmat(min(D, [], 2), 1, size(D,2));
D = D - repmat(min(D, [], 1), size(D,1),1);
[i,j] = find(D <= 10^-10);

line([nodes(i,1), nodes_new(j,1)]', [nodes(i,2), nodes_new(j,2)]', 'Color', 'b')

% return

% edges_new = {};
% for i = 1:M
%   edges_new{i} = [repmat(i, M, 1), [1:M]'];
% end
% edges_new = cat(1,edges_new{:});
% 
% does_intersect = LineSegmentIntersect(nodes, nodes_new, [mst_i,mst_j], edges_new);
% edges_new = edges_new(setdiff(1:size(edges_new,1), does_intersect(:,2)),:);
% 
% line([nodes_new(edges_new(:,1), 1), nodes_new(edges_new(:,2), 1)]', [nodes_new(edges_new(:,1), 2), nodes_new(edges_new(:,2), 2)]', 'Color', [0.5, 0.5, 0.5], 'LineWidth', 1)



nodes_aug = [nodes; nodes_new];
tri = delaunay(nodes_aug(:,1), nodes_aug(:,2));
edges_new = [tri(:,1:2); tri(:,2:3); tri(:,[3,1])];
edges_new = edges_new(all(edges_new > N,2),:)-N;

tic; does_intersect = LineSegmentIntersect(nodes, nodes_new, edges, edges_new); toc
edges_new = edges_new(setdiff(1:size(edges_new,1), does_intersect(:,2))',:);

% line([nodes_new([edges_new(:,1)], 1), nodes_new([edges_new(:,2)], 1)]', [nodes_new([edges_new(:,1)], 2), nodes_new([edges_new(:,2)], 2)]', 'Color', 'r')
% axis image; axis([0,1,0,1]);


edges_new_all = {};
for i = 1:M
  edges_new_all{i} = [repmat(i, M, 1), [1:M]'];
end
edges_new_all = cat(1,edges_new_all{:});

does_intersect = LineSegmentIntersect(nodes, nodes_new, edges, edges_new_all);
edges_new_all = edges_new_all(setdiff(1:size(edges_new_all,1), does_intersect(:,2)),:);
edges_new_all = edges_new_all(edges_new_all(:,1) ~= edges_new_all(:,2),:);

% line([nodes_new([edges_new_all(:,1)], 1), nodes_new([edges_new_all(:,2)], 1)]', [nodes_new([edges_new_all(:,1)], 2), nodes_new([edges_new_all(:,2)], 2)]', 'Color', 'r')
% axis image; axis([0,1,0,1]);

costs = sqrt(sum((nodes_new(edges_new_all(:,1),:) - nodes_new(edges_new_all(:,2),:)).^2,2));
costs(ismember(edges_new_all, edges_new, 'rows')) = costs(ismember(edges_new_all, edges_new, 'rows')) / 10000;

[i,j] = find(graphminspantree(sparse(edges_new_all(:,1), edges_new_all(:,2), costs, M, M)));
edges_new = [i,j];

scatter(nodes_new(:, 1), nodes_new(:, 2), 5, 'ro');
line([nodes_new([edges_new(:,1)], 1), nodes_new([edges_new(:,2)], 1)]', [nodes_new([edges_new(:,1)], 2), nodes_new([edges_new(:,2)], 2)]', 'Color', 'r')
axis image; axis([0,1,0,1]);
plotHelp_setsize(1,1,0.02);

% % Construct a minimum spanning tree of the augmented point set,
% % where the cost of edges that cross the tree are inf, and where we add a
% % bunch of nodes along the rectangle bordering the frame.
% % Make the nodes along the frame have eps cost, but do something to ensure
% % that the tree is fully connected within the frame, and that the missing
% % edge (the one that would make a cycle) is on the outside of the frame.
% 
% % scatter(nodes_aug(:,1), nodes_aug(:,2), 'ro', 'filled')
% 

