function D=zeroDist(P1, P2, interval)
% squared Euclidian distances between vectors

D = sparse(size(P1,1), size(P2,1));

if nargin < 3
  interval = 500;
end

last_len = -1;
t_start = cputime;
t_last = t_start;
for i = 1 : interval : size(P1,1)
    rows = i-1 + [1:interval];
    rows = rows(rows <= size(P1,1));

    X1=repmat(P1(rows,:), [1 size(P2,1)]);
    if size(X1,1) ~= last_len
        X2=repmat(P2,[1 size(X1,1)])';
    end
    last_len = size(X1,1);

    D(rows,:) = sparse(X1 == X2);
    
    t = cputime;
    
    if i > 1 && (t - t_last) > 10
      t_last = t;
      fprintf('ZERODIST: %0.2f%% done, %0.1f minutes left\r', i/size(P1,1)*100, (1/60)*(t-t_start)/i*(size(P1,1)-i));
    end
    
end

end


