(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      5311,        170]
NotebookOptionsPosition[      4834,        150]
NotebookOutlinePosition[      5171,        165]
CellTagsIndexPosition[      5128,        162]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"t", "[", "a", "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "s0"}], " ", "+", " ", 
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"s0", "^", "2"}], " ", "+", " ", 
       RowBox[{"2", "*", "a", "*", "d"}]}], "]"}]}], ")"}], "/", 
   "a"}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"t", "[", "a", "]"}], ",", " ", "a"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s1", "[", "a", "]"}], " ", "=", " ", 
  RowBox[{"s0", " ", "+", " ", 
   RowBox[{
    RowBox[{"t", "[", "a", "]"}], "*", "a"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"s1", "[", "a", "]"}], ",", " ", "a"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Energy", "[", "a", "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s1", "[", "a", "]"}], " ", "*", " ", 
     RowBox[{"(", 
      RowBox[{"K1", " ", "+", " ", 
       RowBox[{"(", 
        RowBox[{"K2", " ", "*", " ", 
         RowBox[{
          RowBox[{"s1", "[", "a", "]"}], "^", "2"}]}], ")"}], " ", "+", " ", 
       RowBox[{"(", 
        RowBox[{"10.32", "*", "M", "*", 
         RowBox[{"(", 
          RowBox[{"g", " ", "+", " ", 
           RowBox[{
            RowBox[{"1.01", "/", "G"}], " ", "*", " ", "a"}]}], ")"}]}], 
        ")"}]}], ")"}]}], ")"}], "/", "1000"}]}]}], "Input",
 CellChangeTimes->{{3.429273592190611*^9, 3.429273615331998*^9}, {
  3.429273649232654*^9, 3.4292737712255917`*^9}, {3.429273908998371*^9, 
  3.4292739625058804`*^9}, {3.429274250333056*^9, 3.429274317316525*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "s0"}], "+", 
   SqrtBox[
    RowBox[{
     RowBox[{"2", " ", "a", " ", "d"}], "+", 
     SuperscriptBox["s0", "2"]}]]}], "a"]], "Output",
 CellChangeTimes->{{3.4292736737400312`*^9, 3.4292737010211477`*^9}, {
  3.429273738437516*^9, 3.4292737716505413`*^9}, {3.429273914545288*^9, 
  3.42927396312193*^9}, {3.429274306180839*^9, 3.429274318737179*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "a"}], " ", "d"}], "+", 
   RowBox[{"s0", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "s0"}], "+", 
      SqrtBox[
       RowBox[{
        RowBox[{"2", " ", "a", " ", "d"}], "+", 
        SuperscriptBox["s0", "2"]}]]}], ")"}]}]}], 
  RowBox[{
   SuperscriptBox["a", "2"], " ", 
   SqrtBox[
    RowBox[{
     RowBox[{"2", " ", "a", " ", "d"}], "+", 
     SuperscriptBox["s0", "2"]}]]}]]], "Output",
 CellChangeTimes->{{3.4292736737400312`*^9, 3.4292737010211477`*^9}, {
  3.429273738437516*^9, 3.4292737716505413`*^9}, {3.429273914545288*^9, 
  3.42927396312193*^9}, {3.429274306180839*^9, 3.429274318740362*^9}}],

Cell[BoxData[
 SqrtBox[
  RowBox[{
   RowBox[{"2", " ", "a", " ", "d"}], "+", 
   SuperscriptBox["s0", "2"]}]]], "Output",
 CellChangeTimes->{{3.4292736737400312`*^9, 3.4292737010211477`*^9}, {
  3.429273738437516*^9, 3.4292737716505413`*^9}, {3.429273914545288*^9, 
  3.42927396312193*^9}, {3.429274306180839*^9, 3.429274318742715*^9}}],

Cell[BoxData[
 FractionBox["d", 
  SqrtBox[
   RowBox[{
    RowBox[{"2", " ", "a", " ", "d"}], "+", 
    SuperscriptBox["s0", "2"]}]]]], "Output",
 CellChangeTimes->{{3.4292736737400312`*^9, 3.4292737010211477`*^9}, {
  3.429273738437516*^9, 3.4292737716505413`*^9}, {3.429273914545288*^9, 
  3.42927396312193*^9}, {3.429274306180839*^9, 3.429274318744596*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox[
    RowBox[{
     RowBox[{"2", " ", "a", " ", "d"}], "+", 
     SuperscriptBox["s0", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"K1", "+", 
     RowBox[{"10.32`", " ", 
      RowBox[{"(", 
       RowBox[{"g", "+", 
        FractionBox[
         RowBox[{"1.01`", " ", "a"}], "G"]}], ")"}], " ", "M"}], "+", 
     RowBox[{"K2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "a", " ", "d"}], "+", 
        SuperscriptBox["s0", "2"]}], ")"}]}]}], ")"}]}], "1000"]], "Output",
 CellChangeTimes->{{3.4292736737400312`*^9, 3.4292737010211477`*^9}, {
  3.429273738437516*^9, 3.4292737716505413`*^9}, {3.429273914545288*^9, 
  3.42927396312193*^9}, {3.429274306180839*^9, 3.4292743187459507`*^9}}]
}, Open  ]]
},
WindowSize->{640, 750},
WindowMargins->{{20, Automatic}, {Automatic, 14}},
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 1652, 47, 103, "Input"],
Cell[2245, 72, 408, 10, 55, "Output"],
Cell[2656, 84, 693, 21, 72, "Output"],
Cell[3352, 107, 337, 7, 38, "Output"],
Cell[3692, 116, 361, 8, 56, "Output"],
Cell[4056, 126, 762, 21, 59, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
